`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/03/26 21:30:49
// Design Name: 
// Module Name: binary_up
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module binary_up(
    output reg [3:0] out1,
    output reg [3:0] out2,
    input clk,
    input rst_n
    );
    reg [3:0] cnt1_tmp1;
    reg [3:0] cnt1_tmp2;
    reg [3:0] cnt2_tmp1;
    reg [3:0] cnt2_tmp2;
    reg [3:0] cnt2_tmp3;
    reg carry;
    
    always@*
    begin
        cnt1_tmp1 = out1 + 1'b1;
        cnt2_tmp1 = out2;
        cnt2_tmp2 = out2 + 1'b1;
    end
    
    always@*
    if(cnt1_tmp1 < 4'b1010)
    begin
        cnt1_tmp2 = cnt1_tmp1;
        carry = 1'b0;
    end
    else
    begin
        cnt1_tmp2 = 4'b0000;
        carry = 1'b1;
    end
    
    always@*
    if((carry & (out2 == 4'b1001)))
        cnt2_tmp3 = 4'b0000;
    else if(carry)
        cnt2_tmp3 = cnt2_tmp2;
    else
        cnt2_tmp3 = cnt2_tmp1;
   
    always@(posedge clk or negedge rst_n)
    if(~rst_n)
    begin
        out1<=4'b0000;
        out2<=4'b0000;
    end    
    else
    begin
        out1<=cnt1_tmp2;
        out2<=cnt2_tmp3;
    end
    
endmodule
